Index: package_tags/invirt-cluster-config/0.0.13/debian/changelog
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/changelog	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/changelog	(revision 2932)
@@ -0,0 +1,83 @@
+invirt-cluster-config (0.0.13) unstable; urgency=low
+
+  * Actually re-generate the corosync.conf file.
+
+ -- Evan Broder <broder@mit.edu>  Tue, 26 Jan 2010 22:29:11 -0500
+
+invirt-cluster-config (0.0.12) unstable; urgency=low
+
+  * Use LVM's built-in cluster locking instead of a separate locking
+    library - this is the behavior prefered by modern LVM.
+  * Use openais for clustering instead of cman!
+
+ -- Evan Broder <broder@mit.edu>  Tue, 26 Jan 2010 21:14:14 -0500
+
+invirt-cluster-config (0.0.11) unstable; urgency=low
+
+  * Configure a fence_manual fencing device, to allow nodes
+    to be properly fenced
+
+ -- Quentin Smith <quentin@mit.edu>  Mon, 28 Dec 2009 03:15:08 -0500
+
+invirt-cluster-config (0.0.10) unstable; urgency=low
+
+  * Don't delete old LVM archives
+
+ -- Quentin Smith <quentin@mit.edu>  Tue, 24 Mar 2009 02:21:13 -0400
+
+invirt-cluster-config (0.0.9) unstable; urgency=low
+
+  * Correctly generate cluster.conf for a two-node cluster.
+
+ -- Evan Broder <broder@mit.edu>  Fri, 30 Jan 2009 05:46:04 -0500
+
+invirt-cluster-config (0.0.8) unstable; urgency=low
+
+  * Add Provides and Conflicts lines to debian/control for
+    config-package-dev
+
+ -- Evan Broder <broder@mit.edu>  Sat, 24 Jan 2009 20:14:39 -0500
+
+invirt-cluster-config (0.0.7) unstable; urgency=low
+
+  * Don't depend on invirt-storage-config
+
+ -- Greg Price <price@mit.edu>  Sat, 27 Dec 2008 00:37:15 -0500
+
+invirt-cluster-config (0.0.6) unstable; urgency=low
+
+  * Apparently there are more bashism in config-init than I thought
+
+ -- Evan Broder <broder@mit.edu>  Mon, 10 Nov 2008 03:53:30 -0500
+
+invirt-cluster-config (0.0.5) unstable; urgency=low
+
+  * Punt unused /etc/default/cman file
+
+ -- Evan Broder <broder@mit.edu>  Mon, 10 Nov 2008 00:08:59 -0500
+
+invirt-cluster-config (0.0.4) unstable; urgency=low
+
+  * Ignore detecting VGs on guests by not scanning any block device nodes
+    in /dev/mapper/xenvg-*
+
+ -- Evan Broder <broder@mit.edu>  Sat, 08 Nov 2008 23:34:06 -0500
+
+invirt-cluster-config (0.0.3) unstable; urgency=low
+
+  * Punt the postinst - it causes more trouble than anything else
+
+ -- Evan Broder <broder@mit.edu>  Thu, 06 Nov 2008 17:58:22 -0500
+
+invirt-cluster-config (0.0.2) unstable; urgency=low
+
+  * Be sure to start clvm as well as cman
+  * Correct the transformation script for lvm.conf
+
+ -- Evan Broder <broder@mit.edu>  Tue, 04 Nov 2008 04:39:45 -0500
+
+invirt-cluster-config (0.0.1) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Evan Broder <broder@mit.edu>  Sat, 01 Nov 2008 15:43:41 -0400
Index: package_tags/invirt-cluster-config/0.0.13/debian/compat
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/compat	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/compat	(revision 2932)
@@ -0,0 +1,1 @@
+5
Index: package_tags/invirt-cluster-config/0.0.13/debian/control
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/control	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/control	(revision 2932)
@@ -0,0 +1,16 @@
+Source: invirt-cluster-config
+Section: servers
+Priority: extra
+Maintainer: Invirt project <invirt@mit.edu>
+Build-Depends: cdbs, debhelper (>= 5), config-package-dev, lvm2
+Standards-Version: 3.8.0
+
+Package: invirt-cluster-config
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, invirt-base,
+ corosync, invirt-openais | openais (>> 1.1.2), clvm
+Provides: ${diverted-files}
+Conflicts: ${diverted-files}
+Description: Cluster configuration for the Invirt project
+ This package should be installed on all Invirt host machines to
+ configure OpenAIS clustering and clustering LVM
Index: package_tags/invirt-cluster-config/0.0.13/debian/copyright
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/copyright	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/copyright	(revision 2932)
@@ -0,0 +1,17 @@
+This software was written for the XVM project <xvm@mit.edu>
+of the MIT Student Information Processing Board.
+
+Copyright :
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+On Debian systems, the complete text of the GNU General Public License
+can be found in the file /usr/share/common-licenses/GPL.
Index: package_tags/invirt-cluster-config/0.0.13/debian/corosync.conf.invirt.mako
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/corosync.conf.invirt.mako	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/corosync.conf.invirt.mako	(revision 2932)
@@ -0,0 +1,33 @@
+<%
+from invirt.config import structs as cfg
+ring = 0
+%>\
+compatibility: whitetank
+
+totem {
+	version: 2
+	secauth: off
+% if len(cfg.cluster.rings) > 1:
+	rrp_mode: passive
+% endif
+% for r in cfg.cluster.rings:
+	interface {
+		ringnumber: ${ring}
+		bindnetaddr: ${r.bind}
+		mcastaddr: ${r.mcast}
+		mcastport: ${r.port}
+	}
+<% ring += 1 %>\
+% endfor
+}
+
+logging {
+	to_syslog: yes
+	syslog_facility: daemon
+	timestamp: on
+	debug: off
+}
+
+amf {
+	mode: disabled
+}
Index: package_tags/invirt-cluster-config/0.0.13/debian/corosync.invirt
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/corosync.invirt	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/corosync.invirt	(revision 2932)
@@ -0,0 +1,5 @@
+# start corosync at boot [yes|no]
+START=yes
+
+# Use openais's clustering instead of corosync
+export COROSYNC_DEFAULT_CONFIG_IFACE="openaisserviceenableexperimental:corosync_parser"
Index: package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.init
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.init	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.init	(revision 2932)
@@ -0,0 +1,16 @@
+#!/bin/bash
+### BEGIN INIT INFO
+# Provides:          invirt-cluster-config
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Invirt clustering configuration
+# Description:       Configure Redhat clustering and clustering LVM
+### END INIT INFO
+
+PACKAGE=invirt-cluster-config
+GEN_FILES=/etc/corosync/corosync.conf.invirt
+
+. /lib/init/config-init.sh
+config_init "$1"
Index: package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.install
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.install	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/invirt-cluster-config.install	(revision 2932)
@@ -0,0 +1,2 @@
+debian/corosync.conf.invirt.mako etc/corosync
+debian/corosync.invirt etc/default
Index: package_tags/invirt-cluster-config/0.0.13/debian/rules
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/rules	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/rules	(revision 2932)
@@ -0,0 +1,11 @@
+#!/usr/bin/make -f
+
+DEB_DIVERT_EXTENSION = .invirt
+DEB_TRANSFORM_FILES_invirt-cluster-config += \
+	/etc/lvm/lvm.conf.invirt
+DEB_DIVERT_FILES_invirt-cluster-config += \
+	/etc/corosync/corosync.conf.invirt \
+	/etc/default/corosync
+
+include /usr/share/cdbs/1/rules/debhelper.mk
+include /usr/share/cdbs/1/rules/config-package.mk
Index: package_tags/invirt-cluster-config/0.0.13/debian/transform_lvm.conf.invirt
===================================================================
--- package_tags/invirt-cluster-config/0.0.13/debian/transform_lvm.conf.invirt	(revision 2932)
+++ package_tags/invirt-cluster-config/0.0.13/debian/transform_lvm.conf.invirt	(revision 2932)
@@ -0,0 +1,4 @@
+#!/usr/bin/perl -0p
+s#^( *filter) = .*#$1 = [ "r|/dev/mapper/xenvg-.*|" ]#m or die;
+s/^( *locking_type) = 1.*$/$1 = 3/m or die;
+s/^( *retain_min) = .*$/$1 = 2147483647/m or die;