Index: package_tags/invirt-host-master/0.0.14/debian/changelog
===================================================================
--- package_tags/invirt-host-master/0.0.14/debian/changelog	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/debian/changelog	(revision 2947)
@@ -0,0 +1,87 @@
+invirt-host-master (0.0.14) unstable; urgency=low
+
+  * Changed dependency debathena-kerberos-config -> invirt-kerberos-config
+
+ -- Greg Brockman <gdb@mit.edu>  Fri, 15 Jan 2010 00:06:17 -0500
+
+invirt-host-master (0.0.13) unstable; urgency=low
+
+  * debathena-ssh-server-config (or any sshd configuration) on the hosts
+    is really a site-local configuration.
+
+ -- Evan Broder <broder@mit.edu>  Thu, 14 Jan 2010 17:10:32 -0500
+
+invirt-host-master (0.0.12) unstable; urgency=low
+
+  * Don't depend on invirt-cluster-config or invirt-storage-config
+
+ -- Greg Price <price@mit.edu>  Sat, 27 Dec 2008 00:35:17 -0500
+
+invirt-host-master (0.0.11) unstable; urgency=low
+
+  * Depend on invirt-cluster-config
+
+ -- Evan Broder <broder@mit.edu>  Sun, 07 Dec 2008 09:43:35 -0500
+
+invirt-host-master (0.0.10) unstable; urgency=low
+
+  * Don't depend on invirt-mail-config
+
+ -- Evan Broder <broder@mit.edu>  Thu, 06 Nov 2008 22:50:05 -0500
+
+invirt-host-master (0.0.9) unstable; urgency=low
+
+  * Depend on invirt-mail-config
+
+ -- Evan Broder <broder@mit.edu>  Thu, 06 Nov 2008 21:40:30 -0500
+
+invirt-host-master (0.0.8) unstable; urgency=low
+
+  * Add dependency on invirt-storage-config
+
+ -- Evan Broder <broder@mit.edu>  Sat, 01 Nov 2008 15:12:50 -0400
+
+invirt-host-master (0.0.7) unstable; urgency=low
+
+  * sipb-xen-autoinstaller-host -> invirt-autoinstaller-host
+
+ -- Evan Broder <broder@mit.edu>  Sat, 01 Nov 2008 04:51:53 -0400
+
+invirt-host-master (0.0.6) unstable; urgency=low
+
+  * sipb-xen-dhcp -> invirt-dhcp
+  * sipb-xen-vnc-server -> invirt-vnc-server
+
+ -- Evan Broder <broder@mit.edu>  Wed, 29 Oct 2008 12:45:15 -0400
+
+invirt-host-master (0.0.5) unstable; urgency=low
+
+  * sipb-xen-base -> invirt-base
+
+ -- Evan Broder <broder@mit.edu>  Tue, 28 Oct 2008 04:23:28 -0400
+
+invirt-host-master (0.0.4) unstable; urgency=low
+
+  * Add invirt-images to dependencies
+
+ -- Evan Broder <broder@mit.edu>  Tue, 28 Oct 2008 04:08:57 -0400
+
+invirt-host-master (0.0.3) unstable; urgency=low
+
+  * sipb-xen-autoinstaller-host has a different name from its
+    source package sipb-xen-autoinstaller
+
+ -- Greg Price <price@mit.edu>  Sat, 25 Oct 2008 23:53:26 -0400
+
+invirt-host-master (0.0.2) unstable; urgency=low
+
+  * remove bitrotten sipb-xen-clvm-config
+
+ -- Greg Price <price@mit.edu>  Sat, 25 Oct 2008 23:45:28 -0400
+
+invirt-host-master (0.0.1) unstable; urgency=low
+
+  * First version as a real package rather than equivs.
+  * Rename from sipb-xen-host-master.
+
+ -- Greg Price <price@mit.edu>  Sat, 25 Oct 2008 21:05:16 -0400
Index: package_tags/invirt-host-master/0.0.14/debian/compat
===================================================================
--- package_tags/invirt-host-master/0.0.14/debian/compat	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/debian/compat	(revision 2947)
@@ -0,0 +1,1 @@
+4
Index: package_tags/invirt-host-master/0.0.14/debian/control
===================================================================
--- package_tags/invirt-host-master/0.0.14/debian/control	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/debian/control	(revision 2947)
@@ -0,0 +1,21 @@
+Source: invirt-host-master
+Section: base
+Priority: extra
+Maintainer: Invirt project <invirt@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0)
+Standards-Version: 3.8.0
+
+Package: invirt-host-master
+Architecture: all
+Description: Master metapackage for Invirt hosts
+ This package depends on everything an Invirt host needs.
+Depends: invirt-xen-config,
+ invirt-autoinstaller-host,
+ invirt-console-host,
+ invirt-remote-host,
+ invirt-images,
+ invirt-base,
+ invirt-dhcp,
+ invirt-vnc-server,
+ invirt-kerberos-config,
+ screen,
Index: package_tags/invirt-host-master/0.0.14/debian/copyright
===================================================================
--- package_tags/invirt-host-master/0.0.14/debian/copyright	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/debian/copyright	(revision 2947)
@@ -0,0 +1,16 @@
+This software was written as part of the Invirt project <invirt@mit.edu>.
+
+Copyright :
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+On Debian systems, the complete text of the GNU General Public License
+can be found in the file /usr/share/common-licenses/GPL.
Index: package_tags/invirt-host-master/0.0.14/debian/rules
===================================================================
--- package_tags/invirt-host-master/0.0.14/debian/rules	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/debian/rules	(revision 2947)
@@ -0,0 +1,3 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/invirt-host-master/0.0.14/notes
===================================================================
--- package_tags/invirt-host-master/0.0.14/notes	(revision 2947)
+++ package_tags/invirt-host-master/0.0.14/notes	(revision 2947)
@@ -0,0 +1,41 @@
+
+# Add eth0 configuration to /etc/network/interfaces
+# - Replace 18.181.0 with 10.5.128
+# - Replace last octet with $((last octet - 205))
+
+# Copy /etc/hosts from another host
+
+# install invirt-base:/etc/apt/sources.list.d/*
+apt-get update
+aptitude install invirt-host-master
+
+# In /etc/default/xendomains
+# - Set XENDOMAINS_MIGRATE to the "next" host
+# - Set XENDOMAINS_SAVE=""
+
+# Add to /etc/rc.local before the "exit 0":
+#  echo -17 > /proc/$(pgrep syslogd)/oom_adj
+
+# In /boot/grub/menu.lst:
+# - Configure remote management for GRUB:
+#     serial --unit=1 --speed=57600 --word=8 --parity=no --stop=1
+#     terminal --timeout=5 serial console 
+# - Configure remote management for Xen:
+#     # xenhopt=console=com2L,vga 
+# - Configure remote management for Linux:
+#     # xenkopt=console=tty0 console=ttyS1,57600n8 
+# - Run update-grub
+
+# install keytab
+
+# Re-order ssh in the boot process to start before cman/clvm, so you
+# can fix it when it inevitably goes bad
+#  update-rc.d -f ssh remove
+#  update-rc.d -f ssh start 16 S . stop 84 0 6 .
+
+# Add to the *bottom* of /etc/sysctl.conf
+#  net.ipv4.conf.eth0.rp_filter=0
+#  net.ipv4.conf.eth1.rp_filter=0
+
+## to take up the new Xen-hypervisor kernel
+# shutdown -r now