Index: package_tags/invirt-iptables/0.0.1/debian/changelog
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/changelog	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/changelog	(revision 2949)
@@ -0,0 +1,9 @@
+invirt-iptables (0.0.1) unstable; urgency=low
+
+  [ Evan Broder ]
+  * Initial Release.
+
+  [ Greg Brockman ]
+  * Make sed not hang when there are no firewall files
+ -- Greg Brockman <gdb@mit.edu>  Mon, 18 Jan 2010 18:50:49 -0500
+
Index: package_tags/invirt-iptables/0.0.1/debian/compat
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/compat	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/compat	(revision 2949)
@@ -0,0 +1,1 @@
+4
Index: package_tags/invirt-iptables/0.0.1/debian/control
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/control	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/control	(revision 2949)
@@ -0,0 +1,13 @@
+Source: invirt-iptables
+Section: base
+Priority: extra
+Maintainer: Invirt project <invirt@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.2.0)
+Standards-Version: 3.8.3
+
+Package: invirt-iptables
+Architecture: all
+Depends: ${misc:Depends}, iptables
+Description: Invirt iptables rules
+ This package allows other packages to distribute iptables rules to be
+ loaded idempotently and atomically at startup.
Index: package_tags/invirt-iptables/0.0.1/debian/copyright
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/copyright	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/copyright	(revision 2949)
@@ -0,0 +1,16 @@
+This software was written as part of the Invirt project <invirt@mit.edu>.
+
+Copyright :
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+On Debian systems, the complete text of the GNU General Public License
+can be found in the file /usr/share/common-licenses/GPL.
Index: package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.dirs
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.dirs	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.dirs	(revision 2949)
@@ -0,0 +1,1 @@
+etc/invirt-iptables/rules.d
Index: package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.init
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.init	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/invirt-iptables.init	(revision 2949)
@@ -0,0 +1,45 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          invirt-iptables
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Invirt iptables rules
+# Description:       
+### END INIT INFO
+
+NAME=invirt-iptables
+DESC="Invirt iptables rules"
+RULES=/etc/invirt-iptables/rules.d
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+
+dpkg -s "$NAME" >/dev/null 2>/dev/null || exit 0
+
+. /lib/init/std-init.sh
+
+do_start()
+{
+        echo 1 > /proc/sys/net/ipv4/ip_forward
+
+	list=$(run-parts --list "$RULES")
+
+	if [ ! -z "$list" ]; then
+            for table in $(sed -ne 's/^*//p' $list); do
+		iptables -t "$table" -F
+            done
+	    cat $list | iptables-restore -n
+	fi
+}
+
+do_reload()
+{
+	do_start
+}
+
+do_stop()
+{
+	return 0
+}
+
+std_init "$1"
Index: package_tags/invirt-iptables/0.0.1/debian/rules
===================================================================
--- package_tags/invirt-iptables/0.0.1/debian/rules	(revision 2949)
+++ package_tags/invirt-iptables/0.0.1/debian/rules	(revision 2949)
@@ -0,0 +1,5 @@
+#!/usr/bin/make -f
+
+DEB_UPDATE_RCD_PARAMS_invirt-iptables = defaults 98 2
+
+include /usr/share/cdbs/1/rules/debhelper.mk